function drawMainMenu() {
	contentArea.removeAllContentItems();

	var send = new ContentItem();
	send.heading = strInvite;
	send.onDetailsView = drawFriends;
	send.flags = gddContentItemFlagNoRemove;
	send.SetRect(0, 0, plugin.window_width, textheight);
	contentArea.addContentItem(send, gddItemDisplayInSidebar);

	var logo = new ContentItem();
	logo.image = imgLogo;
	logo.flags = gddContentItemFlagStatic;
	var xpos = Math.max(0, (plugin.window_width - 78)/2);
	var ypos = Math.max(textheight, (plugin.window_height - 78 - textheight)/2);
	logo.SetRect(xpos, ypos, 78, 78);
	contentArea.addContentItem(logo, gddItemDisplayInSidebar);

	board.visible = false;
	contentArea.visible = true;
	contentArea.height = "100%";
	state = stateMainmenu;
}

function drawFriends() {
	var friends = googleTalk.friends.toArray();

	contentArea.removeAllContentItems();

	var counter = 1;
	for (var i = 0; i < friends.length; i++) {
		if (!friends[i].has_sidebar) continue; // if no sidebar -> go to next friend

		var friend = new ContentItem();
		friend.heading = friends[i].name;
		friend.snippet = friends[i].user_id;
		friend.onDetailsView = OnInvite;
		friend.flags = gddContentItemFlagNoRemove;
		friend.SetRect(17, (textheight*counter), plugin.window_width, textheight);
		//contentArea.addContentItem(friend, gddItemDisplayInSidebar);

		var icon = new ContentItem();
		if (friends[i].status == gddFriendStatusOnline) {
			icon.image = imgOnline;
		} else if (friends[i].status == gddFriendStatusBusy) {
			icon.image = imgBusy;
		} else {
			icon.image = imgAway;
		}

		icon.flags = gddContentItemFlagStatic;
		icon.SetRect(1, (textheight*counter), 16, 16);
		contentArea.addContentItem(icon, gddItemDisplayInSidebar);
		contentArea.addContentItem(friend, gddItemDisplayInSidebar);
		counter++;
	}
	if (counter > 1) {
		// add cancel button
		var cancel = new ContentItem();
		cancel.heading = strCancel;
		cancel.onDetailsView = drawMainMenu;
		cancel.flags = gddContentItemFlagNoRemove;
		cancel.SetRect(0, 0, plugin.window_width, textheight);
		contentArea.addContentItem(cancel, gddItemDisplayInSidebar);

		state = stateInvite;
	} else {
		drawNofriends();
	}
	board.visible = false;
	contentArea.visible = true;
}

function drawNofriends() {
	var label = new ContentItem();
	label.heading = strNoFrOnline;
	label.flags = gddContentItemFlagStatic;
	label.SetRect(0, 0, plugin.window_width, textheight);
	contentArea.addContentItem(label, gddItemDisplayInSidebar);

	var back = new ContentItem();
	back.heading = strBackMM;
	back.onDetailsView = drawMainMenu;
	back.flags = gddContentItemFlagNoRemove;
	back.SetRect(0, textheight, plugin.window_width, textheight);
	contentArea.addContentItem(back, gddItemDisplayInSidebar);

	state = stateNofriends;
}

function drawWaitingScreen() {
	contentArea.removeAllContentItems();

	var label = new ContentItem();
	label.heading = strWaiting;
	label.flags = gddContentItemFlagStatic;
	label.SetRect(0, 0, plugin.window_width, textheight);
	contentArea.addContentItem(label, gddItemDisplayInSidebar);

	var back = new ContentItem();
	back.heading = strBackMM;
	back.onDetailsView = drawMainMenu;
	back.flags = gddContentItemFlagNoRemove;
	back.SetRect(0, textheight, plugin.window_width, textheight);
	contentArea.addContentItem(back, gddItemDisplayInSidebar);

	board.visible = false;
	contentArea.visible = true;
	state = stateWaiting;
}

function onResize() {
	switch (state) {
		case stateMainmenu :
			drawMainMenu();
			break;
		case stateInvite :
			drawFriends()
			break;
		case stateNofriends :
			drawNofriends();
			break;
		case stateWaiting :
			drawWaitingScreen();
			break;
		case stateGame :
			showBoard();
			break;
	}
}

function showBoard() {
	board.visible = true;
	board.x = Math.max(0, (plugin.window_width - board.width)/2);
	board.y = Math.max(textheight, (view.height - board.height)/2);
	contentArea.visible = false;
	contentArea.height = 1;
	state = stateGame;

	for (var i = 0; i < figures.length; i++) {
		for (var a = 0; a < figures[i].length; a++) {
			obj = eval(youPlaywith+"_"+figures[i][a]);
			obj.cursor = "hand";
		}
	}

	yourcolor.innerText = strPlayWith.replace("%color%", (youPlaywith == "w" ? strColorWhite : strColorBlack));
	yourcolor.x = board.x + board.width - yourcolor.offsetWidth;
	yourcolor.y = board.y - textheight;

	whoplayLabel();

	cancelgame.innerText = strCancel;
	cancelgame.x = board.x + board.width - cancelgame.offsetWidth;
	cancelgame.y = board.y + board.height;

	drawn.innerText = strRemi;
	drawn.x = board.x;
	drawn.y = board.y + board.height;
}

function whoplayLabel() {
	whoplay.innerText = yourTurn ? strYourTurn : strWait;
	whoplay.y = board.y - textheight;
	whoplay.x = board.x;
}

function prepareBoard() {
	for (var i = 1; i < 9; i++) {
		for (var a = 0; a < coordsA.length; a++) {
			board.appendElement('<div name="'+coordsA[a]+i+'" background="'+cellBackground+'" opacity="'+Array(Array(whiteColor, blackColor), Array(blackColor, whiteColor))[a%2][i%2]+'" x="'+(boardPadding+((cellSize+1)*a))+'" y="'+(boardPadding+((cellSize+1)*(8-i)))+'" width="'+cellSize+'" height="'+cellSize+'" enabled="true" onclick="boardClick();" />');
		}
	}
	board.appendElement('<div name="game" width="175" height="175" x="3" y="3"></div>');
	prepareFigures();
}
function prepareFigures() {
	for (var i = 0; i < figures.length; i++) {
		for (var a = 0; a < figures[i].length; a++) {
			game.appendElement('<img src="b_'+figures[i][a].substr(0, (figures[i][a].indexOf("_") > 0 ? figures[i][a].indexOf("_") : figures[i][a].length))+'.gif" name="b_'+figures[i][a]+'" width="'+cellSize+'" height="'+cellSize+'" enabled="true" x="'+((1+cellSize)*a)+'" y="'+((1+cellSize)*i)+'" onclick="figureClick();" />');
		}
	}
	for (var i = 0; i < figures.length; i++) {
		for (var a = 0; a < figures[i].length; a++) {
			game.appendElement('<img src="w_'+figures[i][a].substr(0, (figures[i][a].indexOf("_") > 0 ? figures[i][a].indexOf("_") : figures[i][a].length))+'.gif" name="w_'+figures[i][a]+'" width="'+cellSize+'" height="'+cellSize+'" enabled="true" x="'+((1+cellSize)*a)+'" y="'+((7-i)*(cellSize+1))+'" onclick="figureClick();" />');
		}
	}
}

function orderFigures() {
	var obj = null;
	for (var i = 0; i < figures.length; i++) {
		for (var a = 0; a < figures[i].length; a++) {
			obj = eval("b_"+figures[i][a]);
			obj.x = ((1+cellSize)*a);
			obj.y = ((1+cellSize)*i);
			obj.cursor = "arrow";
		}
	}
	for (var i = 0; i < figures.length; i++) {
		for (var a = 0; a < figures[i].length; a++) {
			obj = eval("w_"+figures[i][a]);
			obj.x = ((1+cellSize)*a);
			obj.y = ((7-i)*(cellSize+1));
			obj.cursor = "arrow";
		}
	}
}