// Copyright (c) 2006 Babailiica.
// 
// http://www.babailiica.com/gd/chess.zip

// Google Desktop Chess game.


var imgLogo = graphics.loadImage("logo.gif");
var imgOnline = graphics.loadImage("status_online.gif");
var imgBusy = graphics.loadImage("status_busy.gif");
var imgAway = graphics.loadImage("status_away.gif");

// states:
var state = 0;
var stateMainmenu = 0;
var stateInvite = 1;
var stateNofriends = 2;
var stateWaiting = 3;
var stateGame = 4;

var friend_user_id = "";
var textheight = 18;


// settings
var coordsA = new Array("a", "b", "c", "d", "e", "f", "g", "h");
var coordsA1 = {"a":1, "b":2, "c":3, "d":4, "e":5, "f":6, "g":7, "h":8};
var figures = new Array(
	Array("rock_l", "knight_l", "bishop_l", "queen", "king", "bishop_r", "knight_r", "rock_r"),
	Array("pawn_a", "pawn_b", "pawn_c", "pawn_d", "pawn_e", "pawn_f", "pawn_g", "pawn_h")
);
var whiteColor = 20;
var blackColor = 150;
var cellSize = 21;
var cellBackground ="#000000";
var cellSBackground ="#FF0000";
var cellSugBackground = "#0000FF";
var boardPadding = 3;
var selectedFigure = false;
var nowMoving = false;
var figureFrom = false;
var suggested = new Array();
var youPlaywith = "w";
var yourTurn = false;

// Setup the icons, about dialog and flags.
view.caption = strTitle;
contentArea.contentFlags = gddContentFlagHaveDetails | gddContentFlagManualLayout;
contentArea.maxContentItems = 100;
googleTalk.onReceiveTalkData = OnReceiveTalkData;
plugin.OnDisplayStateChange = onResize;
yourcolor.size = 9;
whoplay.size = 9;
cancelgame.size = 9;
cancelgame.enabled = true;
cancelgame.onclick = cancelgameClick;
cancelgame.cursor = "hand";
drawn.size = 9;
drawn.enabled = true;
drawn.onclick = remigameClick;
drawn.cursor = "hand";
prepareBoard();






function figureTo(figure, x, y) {
	figure = (typeof figure == "string") ? eval(figure) : figure;
	figure.x = (x-1)*(cellSize+1);
	figure.y = (y-1)*(cellSize+1);
}

function figureGoTo(figure, x, y) {
	nowMoving = true;
	figure = (typeof figure == "string") ? eval(figure) : figure;
	var changed = false;
	var rx = (x-1)*(cellSize+1);
	var ry = (y-1)*(cellSize+1);
	var diffx = Math.max(rx, figure.x)-Math.min(rx, figure.x);
	var diffy = Math.max(ry, figure.y)-Math.min(ry, figure.y);
	var diff = (diffx == diffy);
	if (diffx < diffy) {
		if (figure.x < rx) {
			figure.x++;
			changed = true;
		}
		if (figure.x > rx) {
			figure.x--;
			changed = true;
		}
		if ((!changed || diff) && figure.y < ry) {
			figure.y++;
			changed = true;
		}
		if ((!changed || diff) && figure.y > ry) {
			figure.y--;
			changed = true;
		}
	} else {
		if (figure.y < ry) {
			figure.y++;
			changed = true;
		}
		if (figure.y > ry) {
			figure.y--;
			changed = true;
		}
		if ((!changed || diff) && figure.x < rx) {
			figure.x++;
			changed = true;
		}
		if ((!changed || diff) && figure.x > rx) {
			figure.x--;
			changed = true;
		}
	}
	if (changed == true) {
		setTimeout('figureGoTo('+figure.name+', '+x+', '+y+');', 10);
	} else {
		nowMoving = false;
		deselectFigure();
	}
}

function boardClick() {
	if (selectedFigure && !nowMoving && yourTurn && event.srcElement.background == cellSugBackground) {
		try {
			googleTalk.SendTalkData(friend_user_id, "GoTo:"+selectedFigure.name+":"+coordsA1[event.srcElement.name.substr(0, 1)]+":"+(9-event.srcElement.name.substr(1, 1)));
		} catch (e) {
			alert(strConnectionError);
		}
		var f = figureThere(event.srcElement.name.substr(0, 1)+(event.srcElement.name.substr(1, 1)));
		if (f && f.name.substr(0, 1) != youPlaywith) {
			f.visible = false;
			if (f.name.substr(1) == "_king") {
				alert(strWin);
				yourTurn = false;
				whoplayLabel();
				cancelgame.innerText = strCancel;
			}
		}
		figureGoTo(selectedFigure, coordsA1[event.srcElement.name.substr(0, 1)], (9-event.srcElement.name.substr(1, 1)))
		yourTurn = false;
		whoplayLabel();
	} else {
		if (selectedFigure && event.srcElement.background != cellSugBackground) {
			alert(strCantGoThere);
			deselectFigure();
		}
		event.srcElement.name;
	}
	//deselectFigure();
}



function figureClick() {
	if (!selectedFigure &&
		!nowMoving &&
		event.srcElement.name.substr(0, 1) == youPlaywith &&
		yourTurn) {
			selectFigure(event.srcElement);
	} else if (selectedFigure &&
		!nowMoving &&
		selectedFigure.name == event.srcElement.name) {
			deselectFigure();
	}
}
function selectFigure(figure) {
	figure = (typeof figure == "string") ? eval(figure) : figure;
	selectedFigure = figure;
	var coords = getFigureCoords(selectedFigure);
	eval(coords).background = cellSBackground;
	figureFrom = coords;
	figureSuggestions();
}
function deselectFigure() {
	if (figureFrom) {
		eval(figureFrom).background = cellBackground;
		figureFrom = false;
	}
	selectedFigure = false;
	for (var i = 0; i < suggested.length; i++) {
		eval(suggested[i]).background = cellBackground;
		eval(suggested[i]).cursor = "arrow";
	}
	suggested = new Array();
}



function figureType(figure) {
	figure = (typeof figure != "string") ? figure.name : figure;
	return {"type" : figure.replace(/(^(w|b)_)|(_[a-z]$)/ig, ""), "color" : figure.substr(0, 1)};
}




function getFigureCoords(figure) {
	if (typeof figure == "string") {
		figure = eval(figure);
	}
	var x = figure.x/(cellSize+1);
	var y = 8-figure.y/(cellSize+1);
	return coordsA[x]+y;
}




function isFigureThere(coords) {
	for (var i = 0; i < figures.length; i++) {
		for (var a = 0; a < figures[i].length; a++) {
			if (coords == getFigureCoords("w_"+figures[i][a])) {
				return "w";
			} else if (coords == getFigureCoords("b_"+figures[i][a])) {
				return "b";
			}
		}
	}
	return 0;
}

function figureThere(coords) {
	for (var i = 0; i < figures.length; i++) {
		for (var a = 0; a < figures[i].length; a++) {
			if (coords == getFigureCoords("w_"+figures[i][a])) {
				alert("w_"+figures[i][a]);
				return eval("w_"+figures[i][a]);
			} else if (coords == getFigureCoords("b_"+figures[i][a])) {
				alert("b_"+figures[i][a]);
				return eval("b_"+figures[i][a]);
			}
		}
	}
	return false;
}

function cancelGame() {
	selectedFigure = false;
	nowMoving = false;
	figureFrom = false;
	youPlaywith = "w";
	yourTurn = false;
	whoplayLabel();
	drawMainMenu();
	orderFigures();
}













setTimeout("drawMainMenu();", 1);

/////////////////////////////////////////////////////////////////////////////////////////
//                     NETWORK FUNCTIONS
/////////////////////////////////////////////////////////////////////////////////////////

// Invite a friend to play a game
function OnInvite(item) {
	friend_user_id = item.snippet;

	try {
		googleTalk.SendTalkData(friend_user_id, "ComeToPlayAChessGame");
		drawWaitingScreen();
	} catch (e) {
		alert(strConnectionError);
		drawMainMenu();
	}
}

function cancelgameClick() {
	try {
		googleTalk.SendTalkData(friend_user_id, "CancelGame");
	} catch (e) { }
	cancelGame();
}

function remigameClick() {
	try {
		googleTalk.SendTalkData(friend_user_id, "remiGame");
	} catch (e) { }
	cancelGame();
}


function OnReceiveTalkData(friend, data) {
	if (data == "ComeToPlayAChessGame") {
		if (confirm(strWantToPlay.replace("%friend%", friend.name))) {
			try {
				googleTalk.SendTalkData(friend.user_id, "OkPlay");
			} catch (e) {
				alert(strConnectionError);
				drawMainMenu();
			}
			friend_user_id = friend.user_id;
			youPlaywith = "b";
			showBoard();
		} else {
			try {
				googleTalk.SendTalkData(friend.user_id, "NoThanks");
			} catch (e) {
				alert(strConnectionError);
				drawMainMenu();
			}
		}
	} else if (data == "NoThanks") {
		if (state != stateWaiting) {
			try {
				googleTalk.SendTalkData(friend.user_id, "Declined");
			} catch (e) { }
		} else {
			if (confirm(strNoAccept.replace("%friend%", friend.name))) {
				drawFriends();
			} else {
				drawMainMenu();
			}
		}
	} else if (data == "OkPlay") {
		if (state != stateWaiting) {
			try {
				googleTalk.SendTalkData(friend.user_id, "Declined");
			} catch (e) { }
		} else {
			alert(strAccept.replace("%friend%", friend.name));
			showBoard();
			youPlaywith = "w";
			yourTurn = true;
			whoplayLabel();
		}
	} else if (data == "Declined") {
		alert(strTimeout);
	} else if (data.substr(0, 4) == "GoTo" && state == stateGame) {
		data = data.split(":");
		var f = figureThere(coordsA[data[2]-1]+(9-data[3]));
		if (f && f.name.substr(0, 1) == youPlaywith) {
			f.visible = false;
			if (f.name == youPlaywith+"_king") {
				alert(strLose);
				yourTurn = false;
				whoplayLabel();
				cancelgame.innerText = strGameOver;
			}
		}
		figureGoTo(data[1], parseInt(data[2]), parseInt(data[3]));
		yourTurn = true;
		whoplayLabel();
	} else if (data == "CancelGame") {
		cancelGame();
		alert(strCancelGame.replace("%friend%", friend.name));
	} else if (data == "remiGame") {
		cancelGame();
		alert(strRemiMsg.replace("%friend%", friend.name));
	}
}
